#version 150

#moj_import <fog.glsl>

in vec3 Position;
in vec2 UV0;
in vec4 Color;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;

out float vertexDistance;
out vec2 texCoord0;
out vec4 vertexColor;

#moj_import <nlz_utils.glsl>

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);

    vertexDistance = fog_distance(ModelViewMat, Position, FogShape);
    texCoord0 = UV0;
    vertexColor = Color * texelFetch(Sampler2, UV2 / 16, 0);


    vec3 c = rgb2hsv(Color.rgb);
    if (abs(c.x*360 - 300) < 11) {
        vec3 o = rgb2hsv(vec3(255., 240., 148.)/ 255.);
        o.y = mix(o.y, c.y, 0.8);
        o.z = mix(o.z, c.z, 0.2);

        vertexColor = vec4(hsv2rgb(o), Color.a);
    }
}